// Copyright (c) Shenyang Leading Edge Intelligent Technology Co., Ltd. All rights reserved.

package implments

import (
	"LAPP_LF_MOM_BACKEND/grmi"
	meta "LAPP_LF_MOM_BACKEND/meta/base"
	model "LAPP_LF_MOM_BACKEND/models/base"
	"fmt"
	"github.com/go-xorm/xorm"
	"xorm.io/core"
)

/******************************************************************************
 *
 * @Struct Name              : WorkPlacePersonLstDAOImplement
 *-----------------------------------------------------------------------------
 *
 * @Description              : WorkPlacePersonLst的数据访问对象实现
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-04-25 14:20:56
 *
 ******************************************************************************/
type WorkPlacePersonLstDAOImplement struct {
	session *xorm.Session
	meta    *grmi.Entity
	plantNr int
	userid  string
}

/******************************************************************************
 *
 * @Function Name            : NewWorkPlacePersonLstDAOImplement
 *-----------------------------------------------------------------------------
 *
 * @Description              : 创建一个WorkPlacePersonLstDAOImplement实例
 *
 * @Function Parameters      : xorm会话
 *
 * @Function Parameters      : 基本主键
 *
 * @Return Value             : WorkPlacePersonLstDAOImplement实例
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-04-25 14:20:56
 *
 ******************************************************************************/
func NewWorkPlacePersonLstDAOImplement(session *xorm.Session, plantNr int, userid string) *WorkPlacePersonLstDAOImplement {
	return &WorkPlacePersonLstDAOImplement{session, &meta.WorkPlacePersonLst, plantNr, userid}
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/base/WorkPlacePersonLstDAO.InsertOne
 *
 ******************************************************************************/
func (impl *WorkPlacePersonLstDAOImplement) InsertOne(entity *model.WorkPlacePersonLst) error {
	entity.PlantNr = impl.plantNr
	entity.LastUser = impl.userid
	_, err := impl.session.Table(impl.meta.TableName).Insert(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/base/WorkPlacePersonLstDAO.DeleteOne
 *
 ******************************************************************************/
func (impl *WorkPlacePersonLstDAOImplement) DeleteOne(workPlaceNr int, personNr int) error {
	_, err := impl.session.Table(impl.meta.TableName).ID(core.PK{impl.plantNr, workPlaceNr, personNr}).Delete(impl.meta.Indicator)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}

	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/base/WorkPlacePersonLstDAO.SelectOne
 *
 ******************************************************************************/
func (impl *WorkPlacePersonLstDAOImplement) SelectOne(workPlaceNr int, personNr int) (*model.WorkPlacePersonLst, error) {
	var data model.WorkPlacePersonLst
	ok, err := impl.session.Table(impl.meta.TableName).ID(core.PK{impl.plantNr, workPlaceNr, personNr}).Get(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	if !ok {
		return nil, nil
	}
	return &data, nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/base/WorkPlacePersonLstDAO.UpdateOne
 *
 ******************************************************************************/
func (impl *WorkPlacePersonLstDAOImplement) UpdateOne(entity *model.WorkPlacePersonLst) error {
	entity.PlantNr = impl.plantNr
	entity.LastUser = impl.userid
	_, err := impl.session.Table(impl.meta.TableName).Cols(impl.meta.UpdatingMembers...).ID(entity.GetKey()).Update(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/base/WorkPlacePersonLstDAO.Insert
 *
 ******************************************************************************/
func (impl *WorkPlacePersonLstDAOImplement) Insert(entities *[]model.WorkPlacePersonLst) error {
	for i := 0; i < len(*entities); i++ {
		entity := &(*entities)[i]
		entity.PlantNr = impl.plantNr
		entity.LastUser = impl.userid
	}
	_, err := impl.session.Table(impl.meta.TableName).Insert(entities)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/base/WorkPlacePersonLstDAO.Delete
 *
 ******************************************************************************/
func (impl *WorkPlacePersonLstDAOImplement) Delete(entities *[]model.WorkPlacePersonLst) error {
	for _, entity := range *entities {
		entity.PlantNr = impl.plantNr
		_, err := impl.session.Table(impl.meta.TableName).ID(entity.GetKey()).Delete(impl.meta.Indicator)
		if err != nil {
			return grmi.NewDataBaseError(err)
		}
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/base/WorkPlacePersonLstDAO.DeleteWhere
 *
 ******************************************************************************/
func (impl *WorkPlacePersonLstDAOImplement) DeleteWhere(predicates []grmi.Predicate) error {

	parameters := []interface{}{impl.plantNr}
	where := fmt.Sprintf("%s = ?", meta.WorkPlacePersonLst_PlantNr.ColumnName)

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	_, err := session.Delete(impl.meta.Indicator)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/base/WorkPlacePersonLstDAO.Select
 *
 ******************************************************************************/
func (impl *WorkPlacePersonLstDAOImplement) Select(predicates []grmi.Predicate, orderByFields []grmi.Field) ([]model.WorkPlacePersonLst, error) {

	parameters := []interface{}{impl.plantNr}
	where := fmt.Sprintf("%s = ?", meta.WorkPlacePersonLst_PlantNr.ColumnName)

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	session = session.OrderBy(meta.WorkPlacePersonLst_PlantNr.ColumnName)
	if orderByFields != nil {
		for _, field := range orderByFields {
			session = session.OrderBy(field.ColumnName)
		}
	}

	data := make([]model.WorkPlacePersonLst, 0, 10)
	err := session.Find(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	return data, nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/base/WorkPlacePersonLstDAO.SelectAndPaging
 *
 ******************************************************************************/
func (impl *WorkPlacePersonLstDAOImplement) SelectAndPaging(paging *grmi.Paging, predicates []grmi.Predicate, orderByFields []grmi.Field) (grmi.PagingResult, error) {

	parameters := []interface{}{impl.plantNr}
	where := fmt.Sprintf("%s = ?", meta.WorkPlacePersonLst_PlantNr.ColumnName)

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	count, err := session.Count(impl.meta.Indicator)
	if err != nil {
		return grmi.EmptyPagingResult, err
	}

	orderBy := " order by " + meta.WorkPlacePersonLst_PlantNr.ColumnName
	if orderByFields != nil {
		for _, field := range orderByFields {
			orderBy += ", " + field.ColumnName
		}
	}
	parameters = append(parameters, paging.Offset(), paging.Size)
	data := make([]model.WorkPlacePersonLst, 0, 10)
	if where != "" {
		where = " where " + where
	}
	err = impl.session.Table(impl.meta.TableName).SQL("select * from "+impl.meta.TableName+where+orderBy+" offset ? row fetch next ? row only", parameters...).Find(&data)
	if err != nil {
		return grmi.EmptyPagingResult, err
	}
	return grmi.PagingResult{Records: data, Count: count, PageNumber: paging.Number, PageSize: paging.Size}, nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/base/WorkPlacePersonLstDAO.Update
 *
 ******************************************************************************/
func (impl *WorkPlacePersonLstDAOImplement) Update(entities *[]model.WorkPlacePersonLst) error {
	for i := 0; i < len(*entities); i++ {
		entity := &(*entities)[i]
		entity.PlantNr = impl.plantNr
		entity.LastUser = impl.userid
		_, err := impl.session.Table(impl.meta.TableName).Cols(impl.meta.UpdatingMembers...).ID(entity.GetKey()).Update(entity)
		if err != nil {
			return grmi.NewDataBaseError(err)
		}
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/base/WorkPlacePersonLstDAO.UpdateWhere
 *
 ******************************************************************************/
func (impl *WorkPlacePersonLstDAOImplement) UpdateWhere(predicates []grmi.Predicate, entity *model.WorkPlacePersonLst, columns ...string) error {

	parameters := []interface{}{impl.plantNr}
	where := fmt.Sprintf("%s = ?", meta.WorkPlacePersonLst_PlantNr.ColumnName)

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	columns = append(columns, meta.WorkPlacePersonLst_LastUser.ColumnName)
	entity.LastUser = impl.userid
	_, err := impl.session.Table(impl.meta.TableName).Cols(columns...).Update(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/base/WorkPlacePersonLstDAO.UpdateWhere
 *
 ******************************************************************************/
func (impl *WorkPlacePersonLstDAOImplement) SelectAllot(personNr int) ([]model.WorkPlace, error) {

	data := make([]model.WorkPlace, 0)
	session := impl.session.Table("WorkPlace").Join("LEFT", meta.WorkPlacePersonLst.TableName, "WorkPlacePersonLst.PlantNr = WorkPlace.PlantNr and WorkPlacePersonLst.WorkPlaceNr = WorkPlace.WorkPlaceNr").Where("WorkPlacePersonLst.PlantNr = ? and WorkPlacePersonLst.PersonNr = ?", impl.plantNr, personNr)

	err := session.Find(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	return data, nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/base/WorkPlacePersonLstDAO.UpdateWhere
 *
 ******************************************************************************/
func (impl *WorkPlacePersonLstDAOImplement) SelectUnAllot(workSpaces []int) ([]model.WorkPlace, error) {

	data := make([]model.WorkPlace, 0)
	session := impl.session.Table("WorkPlace").Where("PlantNr = ?", impl.plantNr).NotIn("WorkPlaceNr", workSpaces)

	err := session.Find(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	return data, nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/base/WorkPlacePersonLstDAO.SelectPersonByWorkSpace
 *
 ******************************************************************************/
func (impl *WorkPlacePersonLstDAOImplement) SelectPersonByWorkPlace(personId string, workPlaceNr string) (*model.WorkPlacePersonLst, error) {
	var data model.WorkPlacePersonLst
	ok, err := impl.session.Table(impl.meta.TableName).Join("INNER","Person","Person.PlantNr = WorkPlacePersonLst.PlantNr And Person.PersonNr = WorkPlacePersonLst.PersonNr").Where("WorkPlacePersonLst.PlantNr = ? and Person.PersonId = ? and WorkPlacePersonLst.WorkPlaceNr = ?", impl.plantNr, personId, workPlaceNr).Get(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	if !ok {
		return nil, nil
	}
	return &data, nil
}
